/*****************************************************************************************
******************************************************************************************
Nom du fichier : HARDI2C.h
------------------------------------------------------------------------------------------
Auteur: Philippe MARIANO
------------------------------------------------------------------------------------------
Rle: fichier d'en-tte de la bibliothque "HARDI2C.lib"
Cr le: 23/02/2010
Dernire rvision le : 7/1/2011

Cross compilateur utilis: CodeVisionAVR V2
Composant cible : ATMEL 8 bits sur les cartes "SISI" ou "POLOLUSSI"
------------------------------------------------------------------------------------------
Cross compilateur utilis: CodeVisionAVR V2
------------------------------------------------------------------------------------------
Composants cibles : ATMEL 8 bits
------------------------------------------------------------------------------------------
Remarques:
Ce fichier est destin  un projet CVAVR utilisant la carte SISI
Il doit tre plac dans le sous rpertoire \CVAVR2\INC\ ou dans le rpertoire du projet
Placer le fichier HARDI2C.lib dans le rpertoire \CVAVR2\LIB\ ou dans le rpertoire du projet
*****************************************************************************************
*****************************************************************************************/

// -----------------------------------------------------------------------------------------------
#ifndef _HARDI2C_INCLUDED_
#define _HARDI2C_INCLUDED_

// ***********************************************************************************************
// ***********************************************************************************************
// Definitions pour l'interface IHM des cartes ATMEL (SISI ou POLOLUSSI)
// BP et Leds sur I2C
// -----------------------------------------------------------------------------------------------
// Code des BPs
// -----------------------------------------------------------------------------------------------
#ifndef ECHAP_I2C
#define ECHAP_I2C   	128
#endif
#ifndef ENTR_I2C
#define ENTR_I2C 		64
#endif
#ifndef OK_I2C
#define OK_I2C			32
#endif
#ifndef SET_I2C
#define SET_I2C			16
#endif
#ifndef MOINS_I2C
#define MOINS_I2C     	8
#endif
#ifndef FlecheB_I2C
#define FlecheB_I2C 	4
#endif
#ifndef FlecheH_I2C
#define FlecheH_I2C 	2
#endif
#ifndef PLUS_I2C
#define PLUS_I2C     	1
#endif
// -----------------------------------------------------------------------------------------------
// Adresses des Ports E/S I2C PCF8574(P) relis aux BP et aux LED de la carte IHM
// -----------------------------------------------------------------------------------------------
#ifndef Add_LED_I2C_W
#define Add_LED_I2C_W   	0x7E    // SLA+W  (PCF8574)
#endif

#ifndef Add_BP_I2C_R
#define Add_BP_I2C_R   	    0x73  	// SLA+R   (PCF8574)
#endif
// -----------------------------------------------------------------------------------------------

// **********************************************************************************************
// **********************************************************************************************
// Prototypes des fonctions I2C dveloppes pour les cartes SISI ou POLOLUSSI
// **********************************************************************************************
// ----------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------
unsigned char Lire_BP_I2C(unsigned char SLA_R);
/* ----------------------------------------------------------------------------------------------
Rle : Lit l'tat des boutons-poussoirs de l'IHM (PCF8574) relie  la carte ATMEL (SISI ou
POLOLUSSI) par l'intermdiaire de l'interface TWI et renvoie un code sur 8 bits.

Commentaires : Dans un premier temps, la fonction renvoie le code du bouton-poussoir actionn
(PLUS_I2C = 0x01, FlecheH=0x02, FlecheB=0x04, MOINS_I2C = Ox08, SET_I2C = 0x10, OK_I2C = 0x20,
ENTR_I2C=0x40, ECHAP_I2C = 0x80) puis elle renvoie 0xFF si la touche est maintenue ou 0x00 si la
touche est relche.

Entre(s) : 
    SLA_R : octet contenant l'adresse du PCF8574(P) et le bit de lecture

Sortie : code de la touche ou 0x00 ou 0xFF
-----------------------------------------------------------------------------------------------*/

#pragma used-

#pragma library HARDI2C.lib

#endif    // termine la directive ifndef