/*-----------------------------------------------------------------------
Nom du fichier: MSU08
Auteur: Philippe Mariano

Document ressource: 

Rle : Fichier d'en tte pour la commande du module capteur  ultrasons
MSU08

Cr le :  20/01/2012
Dernire rvision le : 20/01/2012

Cross compilateur utilis: CodeVisionAVR V2
Composant cible : ATMEL 8 bits

Remarque: Ce fichier est destin  un projet CVAVR 
Il doit tre plac dans le sous rpertoire \CVAVR\INC\ ou dans le rpertoire
du projet
------------------------------------------------------------------------*/
#ifndef _MSU08_INCLUDED_ 	
#define _MSU08_INCLUDED_

#pragma used+
//==============================================================================================================
// Informations
//==============================================================================================================
// Le module OEM MSU08 dispose de 16 registres
//--------------------------------------------------------------------------------------------------------------
// Adresse              |       Lecture                 |           Ecriture
//--------------------------------------------------------------------------------------------------------------
//      0               | N de la version du logiciel  |   Registre de commande
//      1               | Capteur de lumire            |   Registre Gain MAx (31 par dfaut)
//      2               | 1er cho (octet haut)         |   Registre porte (255 par dfaut)
//      3               | 1er cho (octet bas)          |           N/A
//      |                            |                               |
//      34              | 17me cho (octet haut)       |           N/A     
//      35              | 17me cho (octet bas)        |           N/A
//==============================================================================================================
//--------------------------------------------------------------------------------------------------------------
// Espace d'adressage du module capteur  ultrasons MSU08
//--------------------------------------------------------------------------------------------------------------
// Adresses de base (par dfaut) du module MSU08
//--------------------------------------------------------------------------------------------------------------
#ifndef
#define MSU08_SLA_W				    0xE0        // Octet de l'adresse de base par dfaut + R/W=0  redfinir dans
#endif					                	    // le fichier source du programme si ncessaire

#ifndef
#define MSU08_SLA_R				    0xE1        // Octet de l'adresse de base par dfaut + R/W=1  redfinir dans
#endif										    // le fichier source du programme si ncessaire
// Adresses possibles SLA+W compris entre 0xE0 et 0xFE
//--------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------
// Adresses des registres du module  ultrasons MSU08
//--------------------------------------------------------------------------------------------------------------
#ifndef
#define	MSU08_Reg_SoftRev			     0x00  	    // Version du logiciel (Accessible en lecture)
#endif  
 
#ifndef
#define	MSU08_Reg_Cde			         0x00  	    // Registre de commande (Accessible en criture)
#endif

#ifndef
#define	MSU08_Calpt_Lum			         0x01  	    // Capteur de lumire (Accessible en lecture)
#endif

#ifndef
#define	MSU08_Reg_Gain			         0x01  	    // Registre de rlage du gain (Accessible en criture)
#endif 

#ifndef
#define	MSU08_Echo1_MSB			         0x02  	    // MSB: Distance renvoye par le premier cho (en cm, largeur 
                                                    // d'impulsion ou inch selon la configuration du registre de  
#endif                                              // commande - Accessible en lecture)
#ifndef
#define	MSU08_Echo1_LSB			         0x03  	    // LSB: Distance renvoye par le premier cho (en cm, largeur 
                                                    // d'impulsion ou inch selon la configuration du registre de  
#endif                                              // commande - Accessible en lecture)

                                                    // idem jusqu' 35
//--------------------------------------------------------------------------------------------------------------
// Octets de commmandes du module OEM MSU08
//--------------------------------------------------------------------------------------------------------------
#ifndef
#define	MSU08_MES_INCH			        0x50  	    // Mode de mesure avec rsultat en inches
#endif

#ifndef
#define	MSU08_MES_CM		            0x51  	    // Mode de mesure avec rsultat en cm
#endif

#ifndef
#define	MSU08_MES_MICROS			    0x52  	    // Mode de mesure avec rsultat en microsecondes
#endif

#ifndef
#define	MSU08_ANN_INCH			        0x53  	    // Mode de mesure ANN avec rsultat en inches
#endif

#ifndef
#define	MSU08_ANN_CM		            0x54  	    // Mode de mesure  ANN avec rsultat en cm
#endif

#ifndef
#define	MSU08_ANN_MICROS			    0x55  	    // Mode de mesure  ANN avec rsultat en microsecondes
#endif

#ifndef
#define	SEQ1_ADD_CHANGE			        0xA0  	    // Premire squence pour changer l'adresse I2C
#endif

#ifndef
#define	SEQ2_ADD_CHANGE			        0xA5  	    // Deuxime squence pour changer l'adresse I2C
#endif

#ifndef
#define	SEQ3_ADD_CHANGE			        0xAA  	    // Troisime squence pour changer l'adresse I2C
#endif
//--------------------------------------------------------------------------------------------------------------
#pragma used-

#endif    // termine la directive ifndef