/*****************************************************************************************
******************************************************************************************
Nom du fichier : SISISOL.h
------------------------------------------------------------------------------------------
Auteur: Philippe MARIANO
------------------------------------------------------------------------------------------
Rle: fichier d'en-tte de la bibliothque "SISISOL.lib"
Cr le: 23/02/2010
Dernire rvision le : 16/11/2010

Cross compilateur utilis: CodeVisionAVR V2
Composant cible : ATMEL 8 bits sur carte "SISI"
------------------------------------------------------------------------------------------
Cross compilateur utilis: CodeVisionAVR V2
------------------------------------------------------------------------------------------
Composants cibles : ATMEL 8 bits
------------------------------------------------------------------------------------------
Remarques:
Ce fichier est destin  un projet CVAVR utilisant la carte SSI
Il doit tre plac dans le sous rpertoire \CVAVR2\INC\ ou dans le rpertoire du projet
Placer le fichier SISISOL.lib dans le rpertoire \CVAVR2\LIB\
*****************************************************************************************
*****************************************************************************************/

// -----------------------------------------------------------------------------------------------
#ifndef _SISISOL_INCLUDED_
#define _SISISOL_INCLUDED_

// ***********************************************************************************************
// ***********************************************************************************************
// Definitions pour l'interface IHM de la carte ATMEL SISI
// BP et Leds sur I2C
// -----------------------------------------------------------------------------------------------
// Code des BPs
// -----------------------------------------------------------------------------------------------
#ifndef ECHAP_I2C
#define ECHAP_I2C   	128
#endif
#ifndef ENTR_I2C
#define ENTR_I2C 		64
#endif
#ifndef OK_I2C
#define OK_I2C			32
#endif
#ifndef SET_I2C
#define SET_I2C			16
#endif
#ifndef MOINS_I2C
#define MOINS_I2C     	8
#endif
#ifndef FlecheB_I2C
#define FlecheB_I2C 	4
#endif
#ifndef FlecheH_I2C
#define FlecheH_I2C 	2
#endif
#ifndef PLUS_I2C
#define PLUS_I2C     	1
#endif
// -----------------------------------------------------------------------------------------------
// Adresses des Ports E/S I2C PCF8574 relis au BP et aux LED
// -----------------------------------------------------------------------------------------------
#ifndef Add_LED_I2C_W
#define Add_LED_I2C_W   	0x40    // SLA+W
#endif

#ifndef Add_BP_I2C_R
#define Add_BP_I2C_R   	    0x43  	// SLA+R
#endif
// -----------------------------------------------------------------------------------------------

// **********************************************************************************************
// **********************************************************************************************
// Prototype des fonctions I2C dveloppes pour la carte SISI monte sur un robot solaire
// **********************************************************************************************
// ----------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------
unsigned char Lire_BP_I2C(void);
/* ----------------------------------------------------------------------------------------------
Rle : Lit l'tat des boutons-poussoirs de l'IHM relie  la carte ATMEL S_ISI(PCF8574) par
l'intermdiaire de l'interface TWI et renvoie un code sur 8 bits.

Commentaires : Dans un premier temps, la fonction renvoie le code du bouton-poussoir actionn
(PLUS_I2C = 0x01, FlecheH=0x02, FlecheB=0x04, MOINS_I2C = Ox08, SET_I2C = 0x10, OK_I2C = 0x20,
ENTR_I2C=0x40, ECHAP_I2C = 0x80) puis elle renvoie 0xFF si la touche est maintenue ou 0x00 si la
touche est relche.

Entres : aucunes

Sortie : code de la touche ou 0x00 ou 0xFF
-----------------------------------------------------------------------------------------------*/

#pragma used-

#pragma library SISISOL.lib

#endif    // termine la directive ifndef