/*==============================================================================
Nom du fichier source : TrameIBM.c
Auteur: Philippe MARIANO

Rle: Source de la librairie TrameIBM.lib
Description : Dsrialiser et dcoder une trame au format IBM 
(comme sur les claviers de PC type PS2)
Sources : Note d'application ATMEL AVR313 "interfacing the PC AT Keyboard" 
adaptes au cross compilateur CVAVR V2 et dbarasse du transcodage IBM --> ASCII.

Cr le 23/03/2011 
Dernire rvision le : 28/04/2011

Cross compilateur utilis: CodeVisionAVR V2
Composant cible : Atmel 8 bits 

Remarque: Une fois compil par -> file --> Convert library
le fichier LitClav102.lib est automatiquement plac dans le rpertoire CVAVR\LIB
A placer dans le rpertoire du projet
================================================================================*/

//--------------------------------------------------------------------------------------------------------
// Bibliothques
//--------------------------------------------------------------------------------------------------------
#include <mega8535.h>
//--------------------------------------------------------------------------------------------------------
// Dveloppes pour l'application ( placer dans le rpertoire du projet)
//--------------------------------------------------------------------------------------------------------
#include "TrameIBM.h"
//--------------------------------------------------------------------------------------------------------

//========================================================================================================
//========================================================================================================
// -------------------------------------------------------------------------------------------------------
// Sous programme d'interruption dclench lors de la capture d'un front sur INT0
// -------------------------------------------------------------------------------------------------------
#if funcused ext_int0_isr
interrupt [EXT_INT0] void ext_int0_isr(void)
{
//========================================================================================================
// Variables 
//--------------------------------------------------------------------------------------------------------
//  type 			    Dsignation			            Commentaires
//--------------------------------------------------------------------------------------------------------
//Remarques g_ : variables globales
//--------------------------------------------------------------------------------------------------------
static unsigned int 	g_data = 0; 	  	// Trame transmise
static unsigned char 	g_data_aff;         // Caractre extrait de la trame transmise 

static unsigned char 	edge = 0; 		    // edge = 0 si front descendant; edge =  1 si front montant
					  	                    // (du signal CLK )
static char 		    bitcount_RX = 11;	// Permet de mmoriser le nombre de bits reus 

static unsigned char 	is_up=0;		    // Etat de la touche
					  	                    // is_up = 0 : touche relche
					                        // is_up = 1 : touche actionne
unsigned char 		    i;                  // Compteur d'usage gnral

//========================================================================================================
// Rception de la trame PS2
//--------------------------------------------------------------------------------------------------------
// Dsrialisation 
//--------------------------------------------------------------------------------------------------------
  if (!edge)                                    // Si front descendant
  {// dbut if_1
    if (bitcount_RX < 12 && bitcount_RX > 0)    // Acquisition d'un bit du code
    {                                           // dbut if_2 sur le front descendant de clk
      g_data = (g_data >> 1);
      if (DATA_CLAV)
        g_data = g_data | 0x8000;

    }// fin if_2
    MCUCR = 3;                                  // INT0 actif sur le prochain front montant
    edge = 1;
  }//fin if_1

 else                                           // si front descendant: dcomptage du nombre de bits
  {                                             // Dbut sinon_1 reus sur le front montant
    MCUCR = 2;                                  // INT0 actif sur le prochain front descendant
    edge = 0;
    if (--bitcount_RX == 0)
     { // dbut if3
       g_data = (g_data >> 5);                  // Les 11 bits reus sont positionns dans g_data
                                                // Extraction du code caractre dans
       g_data_aff = (g_data>>1);                // la trame au format PS2
       g_Code_IBM = g_data_aff;
       if (g_flag_char==0)
       g_flag_char = 1;                         // Drapeau prsence message lev
       BUSYIBM = 1;                             // Signal BusyIBM actif
       bitcount_RX = 11;                        // Initialisation du compteur de rception
     }                                          // fin if_3
   }                                            // fin sinon_1

}
//========================================================================================================
#endif
//========================================================================================================
//========================================================================================================

