/*=======================================================================
Nom du fichier: SISISOL.c
Auteur: Philippe MARIANO

Rle: Source de la librairie SISISOL.lib
Cr le 23/02/2010
Dernire rvision le 15/11/2010

Cross compilateur utilis: CodeVisionAVR
Composant cible : Atmel 8 bits (ATMega8535)

Remarque: Une fois compil par -> file --> Convert library
le fichier sisisol.lib est automatiquement plac dans le rpertoire
CVAVR2\LIB
========================================================================*/

#include <delay.h>
#include <stdio.h>
#include "SISISOL.h"
#include "DriverTWICV2.h"

// =============================================================================================================================
// *****************************************************************************************************************************
// *****************************************************************************************************************************
// 				Fonctions pour le robot solaire
// *****************************************************************************************************************************
// 1 Lire_BP_I2C
// *****************************************************************************************************************************
// =============================================================================================================================
#if funcused Lire_BP_I2C
unsigned char Lire_BP_I2C(void)
{
  #define AUCUN	0x00

  unsigned char Frame_I2C_BP_Read[]={0x43,0x00}; 	// Trame de lecture des BP sur l'interface I2C S_ISI{SLA+R=0x43, Data=Nul}

  static enum Etat_I2C {Attente_Relache_BP_I2C,Attente_Appui_BP_I2C} Etat_BP_I2C=Attente_Appui_BP_I2C;

  unsigned char Quel_BP_I2C_1, Quel_BP_I2C;

  // Lecture du clavier
  TWI_Start_Transc_With_Data(Frame_I2C_BP_Read,sizeof(Frame_I2C_BP_Read));  // Envoi de l'octet d'adresse des BP: SLA+R=0x43
																			// Rcupration de l'octet reprsentatif de l'tat des BP
  TWI_Get_Data_From_Transceiver(Frame_I2C_BP_Read,sizeof(Frame_I2C_BP_Read));
  Quel_BP_I2C = Frame_I2C_BP_Read[1];

  switch (Etat_BP_I2C)
   {
    case Attente_Relache_BP_I2C :		// Etat d'attente : relchement de la touche
              if (Quel_BP_I2C == AUCUN) 	// Si on dtecte le relchement de la touche
               {
                 Quel_BP_I2C_1 = Quel_BP_I2C;
                 delay_ms(20); 		// On attend 20ms (traitement des rebonds du contact)
                 TWI_Start_Transc_With_Data(Frame_I2C_BP_Read,sizeof(Frame_I2C_BP_Read));  	// Envoi de l'octet d'adresse des BP: SLA+R=0x43
																						 	// Rcupration de l'octet reprsentatif de l'tat des BP
  				 TWI_Get_Data_From_Transceiver(Frame_I2C_BP_Read,sizeof(Frame_I2C_BP_Read));
                 Quel_BP_I2C = Frame_I2C_BP_Read[1]; // avant de la relire

                 if (Quel_BP_I2C_1 == Quel_BP_I2C) 		// Si elle est bien relche
                  {
                   Etat_BP_I2C = Attente_Appui_BP_I2C; 	// On passe dans l'tat : Attente d'un appui
                   return 0x00; 					// et on sort de la fonction en renvoyant 0
                  }
                 else return 0xff; // sinon la touche est toujours actionne,
               } 		  // On sort de la fonction en renvoyant 0
              else return 0xff;
    break;

    case Attente_Appui_BP_I2C : 	// Etat d'attente : appui sur la touche
    	      if (Quel_BP_I2C != AUCUN) // Si on dtecte qu'une touche est actionne
               {
                 Quel_BP_I2C_1 = Quel_BP_I2C;
                 delay_ms(20);	    // On attend 20ms (traitement des rebonds du contact)
                 TWI_Start_Transc_With_Data(Frame_I2C_BP_Read,sizeof(Frame_I2C_BP_Read));  	// Envoi de l'octet d'adresse des BP: SLA+R=0x43
																						 	// Rcupration de l'octet reprsentatif de l'tat des BP
  				 TWI_Get_Data_From_Transceiver(Frame_I2C_BP_Read,sizeof(Frame_I2C_BP_Read));
                 Quel_BP_I2C = Frame_I2C_BP_Read[1]; // avant de la relire

                 if (Quel_BP_I2C_1 == Quel_BP_I2C)       // Si elle est bien appuye
                  {
                   Etat_BP_I2C = Attente_Relache_BP_I2C; // on passe dans l'tat Attente_relache
                   return Quel_BP_I2C;		 		// et on renvoie son code
                  }
                 else return 0x00; 				// sinon la touche est relche,
               }                    			// On sort de la fonction en renvoyant 255
              else return 0x00;
    break;
   }
}
#endif
// =============================================================================================================================