/****************************************************************************
Nom du fichier:Stkx00.c
Auteur: Philippe MARIANO

Rle: Source de la librairie Stkx00.lib 
Cr le 22/07/06
Dernire rvision le 7/10/06

Cross compilateur utilis: CodeVisionAVR
Composant cible : AT90S8535

Remarque: Une fois compil par -> file --> Convert library
le fichier stk200.lib est automatiquement plac dans le rpertoire CVAVR\LIB 
******************************************************************************/

#include <Stkx00.h>

							
#if funcused ext_int0_isr
interrupt [EXT_INT0] void ext_int0_isr(void)
{
// Variables
/*---------------------------------------------------------------------------------------------
type 			Dsignation			Commentaires		       
----------------------------------------------------------------------------------------------*/
static unsigned int 	g_data = 0; 	  	// trame transmise par le clavier PS2
static unsigned char 	g_data_aff;             // caractre extrait de la trame transmise par le clavier

static unsigned char 	edge = 0; 		// edge = 0 si front descendant; edge =  1 si front montant
					  	// (du signal CLK provenant du clavier)
static char 		bitcount_RX = 11;	// compte le nombre de bits reus du clavier
static char 		bitcount_TX = 10;       // compte le nombre de bits transmis au clavier
 
static unsigned char 	is_up=0;		// etat de la touche
					  	// is_up = 0 : touche relche
					        // is_up = 1 : touche actionne
					        
unsigned char 		i;                      // Compteur d'usage gnral


/* Pour mmoire -------------------------------------------------------------------------------------------------------------
Le programme principal se synchronise avec cette routine d'interruption grace aux quatre variables ci-dessous:

bit g_Sens_transfert = TRANSMISSION;	 		// Indique le sens de la communication C <--> Clavier

// En rception (clavier ->C)
unsigned char 	g_key_ASCII='E'; 		       	// Contient le code ASCII de la touche presse ( initialiser avec un 
							// caractre n'existant pas sur le clavier utilis)
bit   g_flag_char = 0;		       			// drapeau reprsentatif de l'tat de la dernire touche appuye
							// g_flag_char = 1 lorsqu'une touche est appuye 
                                                        // g_flag_char = 0 lorsqu'une touche a t relche
// En transmission (YC -> clavier)							
unsigned int g_Trame_TX = REINITIALISATION_CLAVIER;     // Contient le code  transmettre au clavier
----------------------------------------------------------------------------------------------------------------------------*/


switch (g_Sens_transfert)
{// Debut switch1 
  case 0 : // ------------------------ Rception trame PS2 -----------------------------
// ---------------------------------- Dsrialisation ----------------------------------------   

  if (!edge)                            // Si front descendant
  {// dbut if1
    if (bitcount_RX < 12 && bitcount_RX > 0)// Acquisition d'un bit du code
    {// dbut if2			       sur le front descendant de clk
      g_data = (g_data >> 1);         
      if (DATA_CLAV)
        g_data = g_data | 0x8000;
        
    }// fin if2                      
    MCUCR = 3; // INT0 actif sur le prochain front montant
    edge = 1;
  }//fin if1
 
 else                                 // si front descendant: dcomptage du nombre de bits
  { // Dbut sinon1			reus sur le front montant
    MCUCR = 2; // INT0 actif sur le prochain front descendant
    edge = 0;
    if (--bitcount_RX == 0)
     { // dbut if3
       g_data = (g_data >> 5);        // Les 11 bits reus sont positionns dans g_data
                                      // Extraction du code caractre dans
       g_data_aff = (g_data>>1);      // la trame 
     

// ---------------------------------- Dcodage du caractre reu ------------------------------------------------       
 
      if (!is_up) // si dernier caractre reu = touche relche
        { // dbut if4
          switch (g_data_aff)
           { // dbut switch2
             case 0xf0 ://touche relche
               is_up = 1;
               g_flag_char = 0;
             break;
       
             default:
               for (i = 0; g_Codes_clav_num[i][0] != g_data_aff && g_Codes_clav_num[i][0]; i++);
               if (g_Codes_clav_num[i][0] == g_data_aff) 
               { 
               	g_key_ASCII = g_Codes_clav_num[i][1]; 
               	    
                if (g_flag_char==0)
                 	g_flag_char = 1; 
               }                         
             break;  
          } // fin switch 2
       } // fin if4 
          
       else
         {
          is_up = 0; 
         }	 	    
          bitcount_RX = 11;                // Initialisation du compteur de rception
     } // fin if3   
   } // fin sinon 1
 break; // fin case 0
 
 case 1:  // ------------------------ Emmission trame PS2 -----------------------------
         
         if (bitcount_TX != 0)
             {
              DATA_CLAV = g_Trame_TX;
              bitcount_TX -= 1;
              g_Trame_TX = (g_Trame_TX >> 1);
             }
         else
             {
              bitcount_TX = 10;// Initialisation du compteur de rception
              g_Sens_transfert = RECEPTION; // Mode rception en fin d'mmission
              SENS_DATA_CLAV = ENTREE;   // Broche du signal Data en entre
             }
 break; // fin case 1
 } // fin switch 1
}
#endif


// Gestion de l'afficheur de la carte SSI
//------------------------------------------------------------------------- 
#if funcused Affiche_LCD
void Affiche_LCD(char *ligne1,char *ligne2)
{
	lcd_clear();
        lcd_puts(ligne1);
        lcd_gotoxy(0,1);
        lcd_puts(ligne2);
}
#endif