/*=======================================================================
Nom du fichier:LibRobSuiv.c
Auteur: Philippe MARIANO

Rle: Source de la librairie LibRobSuiv.lib  (PPE RobotSuivLigne)
Cr le 21/01/2010
Dernire rvision le 

Cross compilateur utilis: CodeVisionAVR
Composant cible : Atmel 8 bits (ATMega8535)

Remarque: Une fois compil par -> file --> Convert library
le fichier LibRobSuiv.lib est automatiquement plac dans le rpertoire CVAVR\LIB 

========================================================================*/

#include <LibRobSuiv.h>
#include <PCF8574.h>

// ***************************************************************************************************************
// ***************************************************************************************************************
// 				Fonctions pour la carte Robot SISI 
// ***************************************************************************************************************
// 1 Lire_BP_I2C_Soft 
// ***************************************************************************************************************
//---------------------------------------------------------------------------------------------------------------- 

// =============================================================================================================================
#if funcused Lire_BP_I2C_Soft
unsigned char Lire_BP_I2C_Soft(void)
{ 
  #define AUCUN	0x00
  
  static enum Etat_I2C {Attente_Relache_BP_I2C,Attente_Appui_BP_I2C} Etat_BP_I2C=Attente_Appui_BP_I2C;
  
  unsigned char Quel_BP_I2C, Quel_BP_I2C_1; 
  
  Quel_BP_I2C = Lire_Port_I2C_Soft(Add_BP_I2C); // Lecture du clavier
  
  switch (Etat_BP_I2C)
   {
    case Attente_Relache_BP_I2C :		// Etat d'attente : relchement de la touche
              if (Quel_BP_I2C == AUCUN) 	// Si on dtecte le relchement de la touche
               {
                 Quel_BP_I2C_1 = Quel_BP_I2C; 	  
                 delay_ms(20); 		// On attend 20ms (traitement des rebonds du contact)
                 
                 Quel_BP_I2C = Lire_Port_I2C_Soft(Add_BP_I2C); // Lecture du clavier
                 
                 if (Quel_BP_I2C_1 == Quel_BP_I2C) 		// Si elle est bien relche
                  {
                   Etat_BP_I2C = Attente_Appui_BP_I2C; 	// On passe dans l'tat : Attente d'un appui
                   return 0x00; 					// et on sort de la fonction en renvoyant 0 
                  }
                 else return 0xff; // sinon la touche est toujours actionne, 
               } 		  // On sort de la fonction en renvoyant 0
              else return 0xff; 
    break;
    
    case Attente_Appui_BP_I2C : 	// Etat d'attente : appui sur la touche
    	      if (Quel_BP_I2C != AUCUN) // Si on dtecte qu'une touche est actionne
               {
                 Quel_BP_I2C_1 = Quel_BP_I2C; 
                 delay_ms(20);	    // On attend 20ms (traitement des rebonds du contact)   
                 
                 Quel_BP_I2C = Lire_Port_I2C_Soft(Add_BP_I2C); // Lecture du clavier 
                    
                 if (Quel_BP_I2C_1 == Quel_BP_I2C)       // Si elle est bien appuye
                  {		      		 
                   Etat_BP_I2C = Attente_Relache_BP_I2C; // on passe dans l'tat Attente_relache
                   return Quel_BP_I2C;		 		// et on renvoie son code
                  }
                 else return 0x00; 				// sinon la touche est relche,
               }                    			// On sort de la fonction en renvoyant 255
              else return 0x00; 
    break;
   }
} 
#endif 
// =============================================================================================================================
#if funcused Arret_Moteurs
void Arret_Moteurs()
{
      TCCR1A = 0x00; // Arrt PWM 
      TCCR1B = 0x00; 
      PORTD=0x00;     // Arrt Moteur 
}                                     
#endif 
// =============================================================================================================================
#if funcused Active_Moteurs  
void Active_Moteurs(void)
{
      	TCCR1A=0xF1; // 0xA1 pour robot 2008 0xF1 pour robot 2009
		TCCR1B=0x01;
} 
#endif 
// =============================================================================================================================
#if funcused Affiche_Fleche
void Affiche_Fleche(void)
{
  lcd_gotoxy(15,0);	// Affichage flecheHaut
  lcd_putchar(Caractere_FlecheH);	
  lcd_gotoxy(15,1);	// Affichage flecheBas
  lcd_putchar(Caractere_FlecheB);
}
#endif 
// =============================================================================================================================

// =============================================================================================================================
#if funcused Prise_Balle
// Le robot est arrt dans le SP d'INT0
void Prise_Balle(void) // 	Squence de prise de la balle
{
Cible = 0; // Dsactivation de la dtection de la cible

// Commande du bras (PB0 initialement en sortie et PB0=1)
// ========================================================
CDE_SERVO1 = 1; // Demande sortie du bras
delay_ms(1000);

// Commande de la main
//---------------------------------------------------------
CDE_SERVO2 = 1; // Activation Main
delay_ms(1000);

CDE_SERVO2 = 0; // Dsactivation Main (Economie nergie !)
delay_ms(10);

CDE_SERVO1 = 0;  // Demande rentre du bras
// =======================================================

// Marche Robot
Active_Moteurs();  
}
#endif 
// =============================================================================================================================