/*=======================================================================
Nom du fichier: LCDBATRON.c
Auteur: Philippe MARIANO

Rle: Source de la librairie LCDBATRON.lib
Cr le 23/01/2010
Dernire rvision le 

Cross compilateur utilis: CodeVisionAVR
Composant cible : Atmel 8 bits (ATMega8535)

Remarque: Une fois compil par -> file --> Convert library
le fichier LCDBATRON.lib est automatiquement plac dans le rpertoire CVAVR\LIB 

========================================================================*/

#include <LCDBATRON.h>
//----------------------------------------------------------------------------------------------------------------
// Rcaptilatif des fonctions 
//----------------------------------------------------------------------------------------------------------------
// 1 Init_LCD_I2C_BATRON
// 2 LCD_I2C_BATRON_gotoxy
// 3 Built_Strng_Fram_I2C_LCDBATRON
// 4 Displ_2Lines_On_I2C_LCDBATRON
// 5 Display_Arrow_0n_I2C_LCDBATRON
//---------------------------------------------------------------------------------------------------------------- 
// Cration : Dcembre 2009
// Dernire rvision: Janvier 2010
//---------------------------------------------------------------------------------------------------------------- 
#if funcused Init_LCD_I2C_BATRON
void Init_LCD_I2C_BATRON(void)
{
unsigned char Frame_I2C_LCD_BATRON_Init[]={0x76,0x00,0x34,0x0d,0x06,0x35,0x04,0x10,0x42,0x9F,0x34,0x83,0x02}; 
TWI_Start_Transc_With_Data(Frame_I2C_LCD_BATRON_Init,sizeof(Frame_I2C_LCD_BATRON_Init)); 
}
#endif  
//----------------------------------------------------------------------------------------------------------------
#if funcused LCD_I2C_BATRON_gotoxy
void LCD_I2C_BATRON_gotoxy(unsigned char posx , unsigned char posy) 
{
 unsigned char LCD_BATRON_XY[] = {0x76,0x00,0x80};
 
 if((posx<16)&&(posy<2))
 {
  switch(posy)
  {
    case 0:LCD_BATRON_XY[2]=posx+0x80; break;
    case 1:LCD_BATRON_XY[2]=posx+0xC0; break;
  } 
 }
  TWI_Start_Transc_With_Data(LCD_BATRON_XY, sizeof(LCD_BATRON_XY));
}
#endif  
//---------------------------------------------------------------------------------------------------------------- 
#if funcused Built_Strng_Fram_I2C_LCDBATRON
void Built_Strng_Fram_I2C_LCDBATRON(unsigned char FrameI2C, unsigned char Tstring, int Tstringsize)
{     
 int i; 
 unsigned char *p_Tstring, *p_FrameI2C;
 p_Tstring = Tstring; p_FrameI2C = FrameI2C + 2; 
 
 for(i=0;i<Tstringsize;i++)                  
 { 
 	if (*p_Tstring==0x5B)  *p_FrameI2C=0x8A;
 		else if (*p_Tstring==0x5D)  *p_FrameI2C=0x54;
 			else
  				*p_FrameI2C = *p_Tstring + 0x80;
   	p_Tstring++; p_FrameI2C++;			
 }
 *p_FrameI2C = 0;
}         
#endif 
// ============================================================================================================================= 
#if funcused Displ_2Lines_On_I2C_LCDBATRON
void Displ_2Lines_On_I2C_LCDBATRON(char *Buffer_for_LCD_Line0, char *Buffer_for_LCD_Line1)
{
// Trame de texte compose de: {addLCD, commande criture en DDRAM, e texte  afficher : 16 caractre max,  /0 } 
unsigned char i;
unsigned char Frame_I2C_Lcd_Line[19]={0x76,0x40,0xa0,0xa0,0xa0,0xa0,0xa0,0xa0,0xa0,0xa0,0xa0,0xa0,0xa0,0xa0,0xa0,0xa0,0xa0,0xa0,0};

for (i=0;i<2;i++)  // Effacement de l'cran !
{
  LCD_I2C_BATRON_gotoxy(0,i);
  TWI_Start_Transc_With_Data(Frame_I2C_Lcd_Line,strlen(Frame_I2C_Lcd_Line));
} 
LCD_I2C_BATRON_gotoxy(0,0); 						 	     
Built_Strng_Fram_I2C_LCDBATRON(Frame_I2C_Lcd_Line, Buffer_for_LCD_Line0, strlen(Buffer_for_LCD_Line0)); 
TWI_Start_Transc_With_Data(Frame_I2C_Lcd_Line,strlen(Frame_I2C_Lcd_Line));
LCD_I2C_BATRON_gotoxy(0,1);              
Built_Strng_Fram_I2C_LCDBATRON(Frame_I2C_Lcd_Line, Buffer_for_LCD_Line1, strlen(Buffer_for_LCD_Line1));
TWI_Start_Transc_With_Data(Frame_I2C_Lcd_Line,strlen(Frame_I2C_Lcd_Line));
}  
#endif  
// =============================================================================================================================
#if funcused Display_Arrow_0n_I2C_LCDBATRON
void Display_Arrow_0n_I2C_LCDBATRON(void) 
{
unsigned char Frame_I2C_Lcd_Flash_H[]={0x76,0x40,0x12};
unsigned char Frame_I2C_Lcd_Flash_B[]={0x76,0x40,0x30};

LCD_I2C_BATRON_gotoxy(15,0);
TWI_Start_Transc_With_Data(Frame_I2C_Lcd_Flash_H,sizeof(Frame_I2C_Lcd_Flash_H));  
LCD_I2C_BATRON_gotoxy(15,1);
TWI_Start_Transc_With_Data(Frame_I2C_Lcd_Flash_B,sizeof(Frame_I2C_Lcd_Flash_B));
}   
#endif 
// =============================================================================================================================