/*=============================================================
// Fichier source RC5.lib
// Auteur : Philippe Mariano
// Cre le 10/07/06
// Mise  jour: 07/06
// Version 1.1
Ce fichier contient les sources des sous-programmes ncessaires
au dcodage et la dsrialisation d'une trame RC5 
Composant cible: AT90S8535 
==============================================================*/

#include <RC5.h>


/*=======================================================================================
			 Variables globales
-----------------------------------------------------------------------------------------
 Type			Nom			Rle
----------------------------------------------------------------------------------------*/
unsigned char 	g_Etat = ATTENTE_RC5;       // Variable d'tat du graphe des transitions 
unsigned char 	g_Nb_bits = 14;            // Compteur bits dcods dans la trame reue
// Remarque: ces variables sont dclares globales car elles sont manipules par les deux 
// sous-programmes


/*=======================================================================================
			Sous-programmes
========================================================================================*/

// -----------------------------------------------------------------------------
// Sous programme d'interruption dclench lors de la capture d'un front sur ICP
// -----------------------------------------------------------------------------
interrupt [TIM1_CAPT] void timer1_capt_isr(void)
{
// --------------------  Dbut du graphe Acquisition d'une trame RC5 ----------------------------------------
  switch (g_Etat)  
    {
     case ATTENTE_RC5 :	g_Etat = BIT_PRECEDENT_A_1_RC5; ICP_ATTEND_FRONT_MONTANT;
     			g_Trame = (g_Trame << 1) | 1; g_Nb_bits -= 1; // Chargement g_Trame avec 1 
     break;
     
     case BIT_PRECEDENT_A_1_RC5:	ICP_ATTEND_FRONT_DESCENDANT;
     					if ((duree > TMIN1) && (duree < TMIN2)) // Si temps min 
     			   		g_Etat = ATTENTE_FRONT_DESCENDANT_RC5; 
           		   		else  if ((duree > TMAX1) && (duree < TMAX2))// Si temps max 
           		           		{	
           		            			g_Trame = g_Trame << 1; g_Nb_bits -= 1;  // LSB_TRAME = 0
     			            			g_Etat = BIT_PRECEDENT_A_0_RC5;
     			           		}
     			           	       		else INTERRUPT_DEBORD_PAS_CAPTURE; // Fin de rception si errreur 
     break;
     
     case ATTENTE_FRONT_DESCENDANT_RC5: ICP_ATTEND_FRONT_MONTANT;
					if ((duree > TMIN1) && (duree < TMIN2)) // Si temps min 
					    {
						g_Trame = (g_Trame << 1) | 1; g_Nb_bits -= 1; // LSB_TRAME = 1 
     						g_Etat = BIT_PRECEDENT_A_1_RC5; 
     					    }  
     					    		else INTERRUPT_DEBORD_PAS_CAPTURE; // Fin de rception si errreur       					  		 
    break;
    
    case BIT_PRECEDENT_A_0_RC5:		ICP_ATTEND_FRONT_MONTANT; 
    					if ((duree > TMIN1) && (duree < TMIN2))// Si temps min
     			   			g_Etat = ATTENTE_FRONT_MONTANT_RC5; 
     		           			else if ((duree > TMAX1) && (duree < TMAX2))// Si temps max
        			    			{
           		            				g_Trame = (g_Trame << 1) | 1; g_Nb_bits -= 1; // LSB_TRAME = 0
     			            				g_Etat = BIT_PRECEDENT_A_1_RC5;
     			            			}
     			            			else INTERRUPT_DEBORD_PAS_CAPTURE; // Fin de rception si errreur			         
    break;
    
    case ATTENTE_FRONT_MONTANT_RC5:	ICP_ATTEND_FRONT_DESCENDANT;
    					if ((duree > TMIN1) && (duree < TMIN2))// Si temps min 
    					  { 
    					   g_Trame = g_Trame << 1; g_Nb_bits -= 1;   // LSB_TRAME = 1 
     				           g_Etat = BIT_PRECEDENT_A_0_RC5;
     				          }   
     				          	else INTERRUPT_DEBORD_PAS_CAPTURE; // Fin de rception si errreur
     break;
   } // fin_du_switch 
 
 // --------------------  Fin du graphe Acquisition d'une trame RC5 ----------------------------------------
   
 if (g_Nb_bits == 0)  // Rinitialisation  la fin de la rception d'une trame et positionnement du drapeau 
 {                    // de rception
 	   g_Etat = ATTENTE_RC5;    
 	   g_Nb_bits = 14;
 	   ICP_ATTEND_FRONT_DESCENDANT;
 	   g_Caractere = RECU;
  } 
  
TCNT1 = 0; // Rinitialisation du compteur du timer1
} // fin_de_interrupt [TIM1_CAPT]


// -----------------------------------------------------------------------------
// Sous programme d'interruption dclench lors du dbordement du timer 1
// -----------------------------------------------------------------------------
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
  g_Etat = ATTENTE_RC5; // Rinitialisation
  g_Nb_bits = 14;
  ICP_ATTEND_FRONT_DESCENDANT;
  TCNT1 = 0;
  INTERRUPT_DEBORD_et_CAPTURE;
}