/*-----------------------------------------------------------------------
Nom du fichier: SD21.h
Auteur: Philippe Mariano

Document ressource: http://www.robot-electronics.co.uk/htm/md23tech.htm

Rle : Fichier d'en tte pour la commande de la carte SD21
(Channel Servo Driver Module)
Cr le 08/06/2010
Dernire rvision le

Cross compilateur utilis: CodeVisionAVR
Composant cible : ATMEL 8 bits

Description:

Remarque: Ce fichier est destin  un projet CVAVR utilisant la carte SISI
Il doit tre plac dans le sous rpertoire \CVAVR\INC\ ou dans le
rpertoire du projet
------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------------------------------------
 Commande de la carte SD21 avec les fonctions du driver TWI_Master
----------------------------------------------------------------------------------------------------------------
Pour lire un ou plusieurs des registres de la carte SD21
Avec la fonction "TWI_Start_Transc_With_Data()":
(1) Envoyer la trame 1 compose de { SD21_ADD_BASE_W, Octet_Numro_premier_registre__Lire }  puis
(2) Envoyer la trame 2 compose de{ SD21_ADD_BASE_R, nombre d'emplacements pour les donnes }
Avec la fonction "TWI_Get_Data_From_Transceiver()":
Transfrer le contenu du buffer TWI dans le tableau "MESSAGE"

Pour crire dans un registre de la carte SD21
Avec la fonction "TWI_Start_Transc_With_Data()"
Envoyer la trame { SD21_ADD_BASE_W, Octet_Numro_registre__Ecrire, Valeur__crire }
--------------------------------------------------------------------------------------------------------------*/ 
#ifndef _sd21_INCLUDED_
#define _sd21_INCLUDED_
//--------------------------------------------------------------------------------------------------------------
// Registres de la carte "Moteurs" SD21
//--------------------------------------------------------------------------------------------------------------
// Adresse de base par dfaut
//--------------------------------------------------------------------------------------------------------------
#ifndef
#define SD21_ADD_BASE_W		0xC2    // Adresse de base par dfaut +R/W=0  redfinir dans
#endif					            // le fichier source du programme si ncessaire

#ifndef
#define SD21_ADD_BASE_R		0xC3    // Adresse de base par dfaut +R/W=0  redfinir dans
#endif
//--------------------------------------------------------------------------------------------------------------   
// Commande du servo 1
#ifndef
#define	Servo1		        0		// Numro du registre contenant la vitesse du servo situ  l'emplacent 1
#endif

#ifndef
#define LByte1		        1		//  Numro du registre contenant la position (octet de poids faible) 
#endif                              // du servo situ  l'emplacent 1

#ifndef
#define HByte1		        2		//  Numro du registre contenant la position (octet de poids fort) 
#endif                              //  du servo situ  l'emplacent 1
//--------------------------------------------------------------------------------------------------------------   
// Commande du servo 2
#ifndef
#define	Servo2		        3		// Numro du registre contenant la vitesse du servo situ  l'emplacent 2
#endif

#ifndef
#define LByte2		        4		//  Numro du registre contenant la position (octet de poids faible) 
#endif                              //  du servo situ  l'emplacent 2

#ifndef
#define HByte2		        5		//  Numro du registre contenant la position (octet de poids fort) 
#endif                              // du servo situ  l'emplacent 2
//--------------------------------------------------------------------------------------------------------------   
// Commande du servo 3
#ifndef
#define	Servo3		        6		// Numro du registre contenant la vitesse du servo situ  l'emplacent 3
#endif

#ifndef
#define LByte3		        7		//  Numro du registre contenant la position (octet de poids faible) 
#endif                              // du servo situ  l'emplacent 3

#ifndef
#define HByte3		        8		//  Numro du registre contenant la position (octet de poids fort) 
#endif  					        //  du servo situ  l'emplacent 3 
//--------------------------------------------------------------------------------------------------------------  
// Commande du servo 4
#ifndef
#define	Servo4		        9		// Numro du registre contenant la vitesse du servo situ  l'emplacent 4
#endif

#ifndef
#define LByte4		        10		//  Numro du registre contenant la position (octet de poids faible) 
#endif                              // du servo situ  l'emplacent 4

#ifndef
#define HByte4		        11		//  Numro du registre contenant la position (octet de poids fort) 
#endif                              // du servo situ  l'emplacent 4
//--------------------------------------------------------------------------------------------------------------

#endif
