/*-----------------------------------------------------------------------
Nom du fichier: MD23
Auteur: Philippe Mariano

Document ressource: http://www.robot-electronics.co.uk/htm/md23tech.htm

Rle : Fichier d'en tte pour la commande de la carte MD23
(DUAL 12V 3A H Bridge Motor Device)
Cr le 16/08/2009
Dernire rvision le

Cross compilateur utilis: CodeVisionAVR
Composant cible : ATMEL 8 bits

Description:

Remarque: Ce fichier est destin  un projet CVAVR utilisant la carte SSI
Il doit tre plac dans le sous rpertoire \CVAVR\INC\
------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------------------------------------
 Commande de la carte MD23 avec les fonctions du driver TWI_Master
----------------------------------------------------------------------------------------------------------------
Pour lire un ou plusieurs des registres de la carte MD23
Avec la fonction "TWI_Start_Transc_With_Data()":
(1) Envoyer la trame 1 { MD23_ADD_BASE_W, Octet_Numro_premier_registre__Lire }  puis
(2) Envoyer la trame 2 { MD23_ADD_BASE_R, emplacements libres pour les donnes }
Avec la fonction "TWI_Get_Data_From_Transceiver()":
Transfrer le contenu du buffer TWI dans le tableau message


Pour crire dans un registre
Avec la fonction "TWI_Start_Transc_With_Data()"
Envoyer la trame { MD23_ADD_BASE_W, Octet_Numro_registre__Ecrire, Valeur__crire }
--------------------------------------------------------------------------------------------------------------*/

// Registres de la carte "Moteurs" MD23
//--------------------------------------------------------------------------------------------------------------
// Adresse de base par dfaut
//--------------------------------------------------------------------------------------------------------------
#ifndef
#define MD23_ADD_BASE_W		0xB0    // Adresse de base par dfaut +R/W=0  redfinir dans
#endif					            // le fichier source du programme si ncessaire

#ifndef
#define MD23_ADD_BASE_R		0xB1    // Adresse de base par dfaut +R/W=0  redfinir dans
#endif
//--------------------------------------------------------------------------------------------------------------
// Numro des registres
//--------------------------------------------------------------------------------------------------------------
#ifndef
#define	Reg_Speed1		    0  	    // R/W	Contrle la vitesse du moteur 1  (mode 0,1)
#endif                                  //      ou la vitesse des deux moteurs (mode 2,3)

#ifndef
#define Reg_Speed2_Turn     1	    // R/W	Contrle la vitesse du moteur 2  (mode 0,1)
#endif                                  //      ou la direction (mode 2,3)

#ifndef
#define Reg_Enc1a		    2	    // R    1er octet de l'encodeur 1 (poids fort)
#endif                                  // 	=> capture du compteur lors d'une lecture

#ifndef
#define Reg_Enc1b		    3	    // R	2eme octet de l'encodeur 1
#endif

#ifndef
#define Reg_Enc1c		    4	    // R    3eme octet de l'encodeur 1
#endif

#ifndef
#define Reg_Enc1d		    5	    // R    4eme octet de l'encodeur 1 (poids faible)
#endif

#ifndef
#define Reg_Enc2a		    6	    // R    1er octet de l'encodeur 2 (poids fort)
#endif                              //	=> capture du compteur lors d'une lecture

#ifndef
#define Reg_Enc2b		    7	    // R	2eme octet de l'encodeur 2
#endif

#ifndef
#define Reg_Enc2c		    8	    // R    3eme octet de l'encodeur 2
#endif

#ifndef
#define Reg_Enc2d		    9	    // R    4eme octet de l'encodeur 2 (poids faible)
#endif

#ifndef
#define Reg_VBatterie		10	    // R    Tension de la batterie
#endif

#ifndef
#define Reg_Imot1		    11	    // R    Intensit dans le moteur 1
#endif

#ifndef
#define Reg_Imot2		    12	    // R    Intensit dans le moteur 2
#endif

#ifndef
#define Reg_SoftRev		    13	    // R    Rvision du logiciel
#endif

#ifndef
#define Reg_Acceleration	14	    // R/W  Reglage de l'acclration
#endif

#ifndef
#define Reg_Mode 		    15	    // R/W  Mode de fonctionnement (0,1,2,3)
#endif

#ifndef
#define Reg_Commande		16	    // R/W  Registre de commande
#endif

//--------------------------------------------------------------------------------------------------------------
// Valeurs  placer dans le registre de Mode
//--------------------------------------------------------------------------------------------------------------
#ifndef
#define Mode0	            0	    // Dans Speed1 ou Speed2, 0   => Rotation max inverse
#endif			                    //			  128 => Arrt
			                        //			  255 => Rotation max directe
#ifndef
#define Mode1	            1       // Dans Speed1 ou Speed2, -128  => Rotation max inverse
#endif			                    //			  0 	=> Arrt
			                        //			  127 	=> Rotation max directe
#ifndef
#define Mode2	            2       // Speed1 contrle la vitesse des deux moteurs, Speed2 contrle la direction
#endif			                    // 			  0   => Rotation max inverse
			                        // Pour les deux reg	  128 => Arrt
			                        //			  255 => Rotation max directe
#ifndef
#define Mode3	            3       // Speed1 contrle la vitesse des deux moteurs, Speed2 contrle la direction
#endif			                    //			  -128  => Rotation max inverse
			                        // Pour les deux reg	  0 	=> Arrt
			                        //			  127 	=> Rotation max directe

//--------------------------------------------------------------------------------------------------------------
// Valeurs  placer dans le registre de commande
//--------------------------------------------------------------------------------------------------------------
#ifndef
#define Reset_Encodeur 			32
#endif

#ifndef
#define Desactive_Regulation    48          // Regulation de la vitesse des moteurs
#endif

#ifndef
#define Active_Regulation	    49
#endif

#ifndef
#define Desactive_Timeout_Moteurs	50
#endif

#ifndef
#define Active_Timeout_Moteurs		51      // Arrt des moteurs si pas de transfert pendant 2s
#endif
//**************************************************************************************************************