//-------------------------------------------------------------------------
// Librairie isi.c
// Auteur: Philippe MARIANO 
// Logiciel: CodeVisionAVR
// Cre le 27/06/06
// Dernire rvision le 27/06/06
// Ce fichier est destin  un projet CVAVR utilisant la carte ISI
// Il doit tre plac dans le sous rpertoire \INC
// Composant cible : ATMEGA8535
//-------------------------------------------------------------------------

#include <isi.h> // Contient les dfinitions des entres


// ************************************************************************
//
// Fonctions gnrales de la carte ISI 
// 
// ************************************************************************


// Acquisition de l'tat des entres de la carte SSI
//------------------------------------------------------------------------- 
// Dernire rvision: Juin 2006

#if funcused Lire_Entrees
unsigned int Lire_Entrees(void)
{ 
  #define AUCUNE	0x0000
  
  static enum Etat {Attente_pas_signal_Entree,Attente_signal_Entree} Etat_Entree = Attente_signal_Entree;
  
  unsigned int Quelle_entree_1, Quelle_entree; 
  
  Quelle_entree = 0; 		// lecture de l'tat des entrees de la carte ISI
  Quelle_entree = PINA;         // prise en compte d'une seule entre
  Quelle_entree = Quelle_entree<<1;
  Quelle_entree = Quelle_entree |PIND.1;
  Quelle_entree = Quelle_entree<<1;
  Quelle_entree = Quelle_entree |PIND.0;
  Quelle_entree = ~(Quelle_entree |0b1111110000000000);  
                                    
  switch (Etat_Entree)
   {
    case Attente_pas_signal_Entree :			  // Etat d'attente : absence de signal sur les entrees
              if (Quelle_entree == AUCUNE) 		  // Si il n'y a pas de signal
               {
                 Quelle_entree_1 = Quelle_entree; 	  // On attend 20ms (traitement des faux contacts)
                 delay_ms(20);                            // avant de relire les entres
                 Quelle_entree = 0; 			  // Lecture de l'tat des entrees de la carte ISI
  		 Quelle_entree = PINA;         		  // prise en compte d'une seule entre
  		 Quelle_entree = Quelle_entree<<1;
  		 Quelle_entree = Quelle_entree |PIND.1;
  		 Quelle_entree = Quelle_entree<<1;
  		 Quelle_entree = Quelle_entree |PIND.0;
  		 Quelle_entree = ~(Quelle_entree |0b1111110000000000);   
                 
                 if (Quelle_entree_1 == Quelle_entree) 	   // Si il n'y a effectivement pas de signal
                  {
                   Etat_Entree = Attente_signal_Entree;    // On passe dans l'tat : Attente d'un signal
                   return 0xffff; 			   // et on sort de la fonction en renvoyant 655355 
                  }
                 else return 0x00; 			   // sinon le signal est toujours prsent 
               } 		  			   // On sort de la fonction en renvoyant 0
              else return 0x00; 
    break;
    
    case Attente_signal_Entree : 				// Etat d'attente : prsence d'un signal sur une entre
    	      if (Quelle_entree != AUCUNE) 		// Si on dtecte un signal
               {
                 Quelle_entree_1 = Quelle_entree; 	// On attend 20ms (traitement des rebonds du contact)
                 delay_ms(20);	      			// avant de relire les entres 
                 Quelle_entree = 0; 			// Lecture de l'tat des entrees de la carte ISI
  		 Quelle_entree = PINA;         		// prise en compte d'une seule entre
  		 Quelle_entree = Quelle_entree<<1;
  		 Quelle_entree = Quelle_entree |PIND.1;
  		 Quelle_entree = Quelle_entree<<1;
  		 Quelle_entree = Quelle_entree |PIND.0;
  		 Quelle_entree = ~(Quelle_entree |0b1111110000000000);        
                 
                 if (Quelle_entree_1 == Quelle_entree)       // Si le signal est bien prsent
                  {		      		 
                   Etat_Entree = Attente_pas_signal_Entree;  // on passe dans l'tat Attente_pas_signal
                   return Quelle_entree;		     // et on renvoie son code
                  }
                 else return 0xffff; // sinon le signal est absent,
               }                    // On sort de la fonction en renvoyant 65535
              else return 0xffff; 
    break;
   }
} 
#endif
       
    
// Gestion de l'afficheur de la carte SSI
//------------------------------------------------------------------------- 
// Dernire rvision: Mars 2003

#if funcused Affiche_LCD
void Affiche_LCD(char *ligne1,char *ligne2)
{
	lcd_clear();
        lcd_puts(ligne1);
        lcd_gotoxy(0,1);
        lcd_puts(ligne2);
}
#endif


