/*****************************************************************************************
******************************************************************************************
Nom du fichier:SOMO14D.c
------------------------------------------------------------------------------------------
Auteur: Philippe MARIANO
------------------------------------------------------------------------------------------
Rle: fichier source de la librairie SOMO14D.lib
------------------------------------------------------------------------------------------
Cr le : 02/03/2011
Dernire rvision le : 
------------------------------------------------------------------------------------------
Cross compilateur utilis: CodeVisionAVR V2.04.08
------------------------------------------------------------------------------------------
Composants cibles : ATMEL 8 bits
------------------------------------------------------------------------------------------
CIBLE HARDWARE: Carte pour les TP ATMEL SSI V1 ou V2
------------------------------------------------------------------------------------------
Remarques: Une fois compil par -> file --> Convert library
le fichier SOMO14D.lib est automatiquement plac dans le rpertoire CVAVR\LIB 
*****************************************************************************************
*****************************************************************************************/

// ***************************************************************************************************************
// Librairies 
// ***************************************************************************************************************
#include <mega8535.h> // Contient la dfinition des ports
#include <delay.h>      // Contient la fonction delay_ms
#include "SOMO14D.h"
// ***************************************************************************************************************

// ***************************************************************************************************************
// ***************************************************************************************************************
// 				Fonctions pour la commande du module audio SOMO-14D
// ***************************************************************************************************************
// Rcapitulatif
// 0) void InitSOMO14D(void);
// 1) void AttendreFinSonSomo14D(void);
// 2) void Somo14DReset(void);
// 3) void Somo14DStart(void);
// 4) void Somo14DStop(void);
// 5) void Somo14DTransfertInt(unsigned int Value);
// 6) void Somo14DReglageVolume(unsigned char Volume); 
// 7) void SendFrameToSomo14D(unsigned int value);
// ***************************************************************************************************************
//----------------------------------------------------------------------------------------------------------------
// 0) Initialisation du module
//----------------------------------------------------------------------------------------------------------------
// Cration : Mars 2011
// Dernire rvision: 
//----------------------------------------------------------------------------------------------------------------
#if funcused InitSOMO14D
void InitSOMO14D(void)
{
    Reset = 1;
    Clk = 1;
    delay_ms(100);
    Somo14DReset();  
}
//----------------------------------------------------------------------------------------------------------------
#endif
//----------------------------------------------------------------------------------------------------------------
// 1) Attente tant que le dernier morceau n'est pas termin
//----------------------------------------------------------------------------------------------------------------
// Cration : Mars 2011
// Dernire rvision: 
//----------------------------------------------------------------------------------------------------------------
#if funcused AttendreFinSonSomo14D
//----------------------------------------------------------------------------------------------------------------
void AttendreFinSonSomo14D(void)
{
delay_ms(20); // tBUSYmin = 20ms (chronogrammes SOMO-14D)
do {;} while(Busy == 1) ; 
}
//----------------------------------------------------------------------------------------------------------------
#endif
//----------------------------------------------------------------------------------------------------------------
// 2) Reset du module SOMO-14D
//----------------------------------------------------------------------------------------------------------------
// Cration : Mars 2011
// Dernire rvision: 
//----------------------------------------------------------------------------------------------------------------
#if funcused Somo14DReset
//----------------------------------------------------------------------------------------------------------------
void Somo14DReset(void)
{
    Reset = 0;
    delay_ms(10);       // tRPmin = 5ms (chronogrammes SOMO-14D)
    Reset = 1;
    delay_ms(500);      // tRESETmin = 300ms (chronogrammes SOMO-14D)
}
//----------------------------------------------------------------------------------------------------------------
#endif
//----------------------------------------------------------------------------------------------------------------
// 3) Gnration d'un Start (voir chronogrammes dans doc SOMO-14D)
//----------------------------------------------------------------------------------------------------------------
// Cration : Mars 2011
// Dernire rvision: 
//----------------------------------------------------------------------------------------------------------------
#if funcused Somo14DStart
//----------------------------------------------------------------------------------------------------------------
void Somo14DStart(void)
{
 Clk = 0;        
 delay_us(2500);        // tStartmin = 2ms (chronogrammes SOMO-14D) 
} 
//----------------------------------------------------------------------------------------------------------------
#endif
//----------------------------------------------------------------------------------------------------------------
// 4) Gnration d'un Stop (voir chronogrammes dans doc SOMO-14D)
//----------------------------------------------------------------------------------------------------------------
// Cration : Mars 2011
// Dernire rvision: 
//----------------------------------------------------------------------------------------------------------------
#if funcused Somo14DStop
//---------------------------------------------------------------------------------------------------------------- 
void Somo14DStop(void)
{
    Clk = 1;      
    delay_us(2500);     // tStopmin = 2ms  (chronogrammes SOMO-14D) 
}
//----------------------------------------------------------------------------------------------------------------
#endif
//----------------------------------------------------------------------------------------------------------------
// 5) Srialisation sur la sortie DATA d'une donne sur 16 bits et gnration du signal d'horloge sur Clk
//----------------------------------------------------------------------------------------------------------------
// Cration : Mars 2011
// Dernire rvision: 
//----------------------------------------------------------------------------------------------------------------
#if funcused Somo14DTransfertInt
//----------------------------------------------------------------------------------------------------------------
void Somo14DTransfertInt(unsigned int Value)
{
    int MSB;
    char i;
    
    for (i=0;i<16;i++)
        {
            Clk = 0;
            MSB = Value & 0x8000;
            if (MSB == 0) Data = 0;  else Data = 1;
            delay_us(150);      // tCLmin = 100s
            Clk = 1;
            delay_us(150);      // tCHmin = 100s
            Value = Value << 1;
        }
}
//----------------------------------------------------------------------------------------------------------------
#endif
//----------------------------------------------------------------------------------------------------------------
// 6) Rglage du volume de la sortie audio du module
//----------------------------------------------------------------------------------------------------------------
// Cration : Mars 2011
// Dernire rvision: 
//----------------------------------------------------------------------------------------------------------------
#if funcused Somo14DReglageVolume
//----------------------------------------------------------------------------------------------------------------
void Somo14DReglageVolume(unsigned char Volume)
{
    Somo14DStart();
    Somo14DTransfertInt(0xFFF0 + (int)Volume);
    Somo14DStop();
}
//----------------------------------------------------------------------------------------------------------------
#endif
//----------------------------------------------------------------------------------------------------------------
// 7) Envoie d'une donne prcde de Start et suivie par Stop
//----------------------------------------------------------------------------------------------------------------
// Cration : Mars 2011
// Dernire rvision: 
//----------------------------------------------------------------------------------------------------------------
#if funcused SendFrameToSomo14D
//----------------------------------------------------------------------------------------------------------------
void SendFrameToSomo14D(int Value)
{
  Somo14DStart();
  Somo14DTransfertInt(Value);
  Somo14DStop();
}
//----------------------------------------------------------------------------------------------------------------
#endif
//----------------------------------------------------------------------------------------------------------------